/*
	Date:				February 16, 1993

	Written By:			Daniel Ambrose

	CIS id:				71062,523

*/


#define Uses_TApplication
#define Uses_TBackground
#define Uses_TButton
#define Uses_TKeys
#define Uses_TDeskTop
#define Uses_TDialog
#define Uses_TMenu
#define Uses_TMenuBar
#define Uses_TMenuItem
#define Uses_TSubMenu
#define Uses_TRect
#define Uses_TStaticText
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TStatusLine
#include <tv.h>

#include "ttywin.h"
#include "debug.h"

const cmAbout   			= 100;	// User selected menu item 'About'
const cmTry					= 101;
const cmTrace				= 102;


	otstream *debout;			//	for global access

class TApp : public TApplication
{
public:
	TApp();
	static TMenuBar *initMenuBar( TRect r );
	static TDeskTop *initDeskTop( TRect r );
	void handleEvent( TEvent &event );
	void AboutDialog();

};


TApp::TApp() : TProgInit( &TApplication::initStatusLine,
				&TApp::initMenuBar, &TApp::initDeskTop )
{
	TTerminal *term;
	TTYWindow * ttyWin;
	ttyWin = new TTYWindow(TRect(20,11,60,20),"TTY Demo",
		wnNoNumber, term, 2048);
	debout = new otstream(term);
	deskTop->insert(ttyWin);

	dout << "TTYWindow & Trace Demo Program" << endl;
	dout << "Written by:  Dan Ambrose 71062,523" << endl;

}

TMenuBar *TApp::initMenuBar( TRect r )
{
	r.b.y = r.a.y + 1;

	return new TMenuBar( r,
	*new TSubMenu( "~M~enu", kbAltM )+
		*new TMenuItem( "~A~bout", cmAbout, kbAltA, hcNoContext, "Alt-A" )+
		newLine()+
		*new TMenuItem( "~T~TY", cmTry, kbAltT, hcNoContext, "Alt-T" )+
		*new TMenuItem( "T~r~ace", cmTrace, kbAltR, hcNoContext, "Alt-R" )+
		newLine()+
		*new TMenuItem( "E~x~it", cmQuit, cmQuit, hcNoContext, "Alt-X" )
	);
}

TDeskTop *TApp::initDeskTop( TRect r )
{
	r.a.y++;
	r.b.y--;
	return new TDeskTop( r );
}

void TApp::handleEvent (TEvent &event)
{
	TApplication::handleEvent( event );
	if( event.what == evCommand )
	{
		switch( event.message.command )
		{
		case cmAbout:
			AboutDialog();
			clearEvent( event );
			break;

		case cmTry:
			void tryTTY(void);			//	global function prototype
			tryTTY();					//	call global function
			clearEvent( event );
			break;

		case cmTrace:
			void tryTrace(void);		//	global function prototype
			tryTrace();					//	call global function
			clearEvent( event );
			break;

		}
	}
}


void TApp::AboutDialog()
{
	TDialog *pd = new TDialog( TRect( 0, 0, 35, 12 ), "About" );

	if (!validView(pd))
		return;

	pd->options |= ofCentered;
	pd->insert( new TStaticText( TRect( 1, 2, 34, 7 ),
		"\003Turbo Vision\n\003\n"
		"\003Class TTYWindow\n\003\n"
		"\003Dan Ambrose   CIS:71062,523"));

	pd->insert( new TButton( TRect( 3,9,32,11 ), "~O~k",
		cmOK, bfDefault ) );

	deskTop->execView( pd );

	destroy( pd );
}

int main(void)
{
	TApp myApp;
	myApp.run();
	return 0;
}
